<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Orcid-Resume</title>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.css">
</head>
<body>
    <div id="root" style="margin: 50px">
        <div class="ui icon input">
            <input id="orcidId" type="text" placeholder="Orcid Id...">
            <i id="selectOrcidId" class="inverted circular angle right link icon"></i>
        </div>
        <a id="update" class="ui active button">
            <i class="sync icon"></i>
            Atualizar dados
        </a>

        <div class="ui top attached tabular menu">
            <a id="bio" class="active item">
                Bio
            </a>
            <a id="works" class="item">
                Works
            </a>
            <a id="educations" class="item">
                Educations
            </a>
        </div>
        <div id="list" class="ui bottom attached segment">
        </div>
    </div>

    <div class="ui modal">
        <div class="header modal_title">Header</div>
        <div class="content">
            <p><b>Publication Name:</b> <span class="modal_publication_name"></span> (<span class="modal_type"></span>)</p>
            <p><b>Publisher:</b> <span class="modal_publisher"></span></p>
            <p><b>Date:</b> <span class="modal_cover_date"></span></p>
            <p><b>ISSN:</b> <span class="modal_issn"></span></p>
            <p><b>URL:</b> <a class="modal_url"></a></p>

            <div class="ui divider"></div>

            <p><b>Authors:</b></p>
            <div class="modal_authors"></div>
        </div>
    </div>

    <script
            src="https://code.jquery.com/jquery-3.5.1.min.js"
            integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0="
            crossorigin="anonymous">
    </script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/semantic-ui/2.4.1/semantic.min.js"></script>

    <script>
        const url = "http://localhost:3000"
        let orcidId = "";
        let page = 0;

        $("#bio").click(() => {
            $("#bio").addClass("active");
            $("#works").removeClass("active");
            $("#educations").removeClass("active");

            bio();
        });

        $("#works").click(() => {
            $("#bio").removeClass("active");
            $("#works").addClass("active");
            $("#educations").removeClass("active");

            page = 0;
            works();
        });

        $("#educations").click(() => {
            $("#bio").removeClass("active");
            $("#works").removeClass("active");
            $("#educations").addClass("active");

            page = 0;
            educations();
        });

        $("#selectOrcidId").click(() => {
            orcidId = $('#orcidId').val();

            $("#bio").addClass("active");
            $("#works").removeClass("active");
            $("#educations").removeClass("active");

            bio();
        });

        $("#update").click(() => {
            if (orcidId === "") {
                return;
            }

            $.get(`${url}/users/${orcidId}/works/update`);
            $.get(`${url}/users/${orcidId}/educations/update`);
        });

        function bio() {
            $('#list').empty();

            $.get(`${url}/users/${orcidId}`, data => {
                $('#list').append(
                    '<i class="user icon"></i> <span id="name">' + data.givenNames + ' ' + data.familyName + '</span>' +
                    '<br />' +
                    '<i class="book icon"></i> Scopus Author Id: <a href="https://www.scopus.com/authid/detail.uri?authorId=' + data.scopusAuthorId + '" target="_blank">' + data.scopusAuthorId + '</a>' +
                    '<br /><br /><br />' +
                    '<i class="edit icon"></i> <span id="biography" style="line-height: 2em;">' + data.biography + '</span>'
                );
            });
        }

        function work(e) {
            const id = $(e.target).attr('wid');

            $.get(`${url}/users/${orcidId}/works/${id}`, data => {
                if (data.error === true) {
                    return;
                }

                const info = data['abstracts-retrieval-response'].coredata;

                $('.modal_title').text(info['dc:title']);
                $('.modal_publisher').text(info['dc:publisher']);
                $('.modal_cover_date').text(info['prism:coverDate']);
                $('.modal_issn').text(info['prism:issn']);
                $('.modal_publication_name').text(info['prism:publicationName']);

                const $_url = $('.modal_url');
                $_url.text(info['prism:url']);
                $_url.prop('href', info['prism:url']);

                $('.modal_type').text(info['subtypeDescription']);

                const $_authors = $('.modal_authors');
                $_authors.empty();

                info['dc:creator']["author"].forEach(author => {
                    $_authors.append('<p>- <a target="_blank" href="' + author['author-url'] +'">' + author['ce:given-name'] + ' ' + author['ce:surname']  + '</a></p>')
                })

                $('.ui.modal')
                    .modal('show')
                ;
            });
        }

        function works() {
            $.get(`${url}/users/${orcidId}/works?page=${page}`, data => {
                $('#list').empty();

                data.results.forEach(work => {
                    const date = '<div style="margin-top: 5px" class="description">' +
                        '<i class="small calendar alternate arrow icon"></i>' +
                        new Date(work.date).toLocaleDateString() + '</div>';

                    const citations = work.citations !== null ? '  (' + work.citations + ' citations)' : '';

                    const doi = work.doi !== null ?
                        '<div style="margin-top: 8px" class="description">DOI: <a href="https://www.doi.org/' + work.doi + '" target="_blank">' + work.doi + '</a>' + citations + '</div>'
                        : '';

                    const eid = work.eid !== null ?
                        '<div style="margin-top: 8px" class="description">EID: ' + work.eid + '</a></div>'
                        : '';

                    $('#list').append(
                        '<div class="item" style="margin-bottom: 30px">' +
                        '    <i class="large newspaper middle aligned icon"></i>' +
                        '    <a class="header title" wId="' + work.id + '">' + work.title + '</a>' +
                        '    <div class="content">' +
                        '        <i class="small paperclip middle aligned icon"></i>' +
                        '        <span style="text-transform: capitalize">' + work.type.toLowerCase().replace('_', ' ') + '</span>' +
                                 date +
                                 doi +
                                 eid +
                        '    </div>' +
                        '</div>'
                    );
                });

                $('.title').on('click', work);

                const pages = parseInt(data.total / 10);

                $('#list').append('<div id="pages" class="ui pagination menu">');

                for (let i = page - 6; i < page; i++) {
                    if (i >= 0) {
                        $('#pages').append('<a class="item pageChoice">' + i + '</a>');
                    }
                }

                $('#pages').append('<a class="active item pageChoice">' + page + '</a>');

                for (let i = page + 1; i <= pages && i <= page + 5; i++) {
                    $('#pages').append('<a class="item pageChoice">' + i + '</a>');

                    if (i === page + 5) {
                        $('#pages').append('<a class="item">...</a>');
                    }
                }

                $('.pageChoice').click(event => {
                    page = parseInt(event.target.innerText);

                    works();
                });
            });
        }

        function educations() {
            $.get(`${url}/users/${orcidId}/educations?page=${page}`, data => {
                $('#list').empty();

                data.results.forEach(education => {
                    const date = '<div style="margin-top: 5px" class="description">' +
                        '<i class="small calendar alternate arrow icon"></i>' +
                        new Date(education.startDate).toLocaleDateString() +
                        ' - ' +
                        (education.endDate !== null ? new Date(education.endDate).toLocaleDateString() : '_') +
                        '</div>';


                    $('#list').append(
                        '<div class="item" style="margin-bottom: 30px">' +
                        '    <i class="large book middle aligned icon"></i>' +
                        '    <a class="header">' + education.roleTitle + '</a>' +
                        '    <div class="content" style="margin-top: 10px">' +
                        '        <i class="small location arrow icon"></i>' +
                        education.organizationName +
                        date +
                        '    </div>' +
                        '</div>'
                    );
                });

                const pages = parseInt(data.total / 10);

                $('#list').append('<div id="pages" class="ui pagination menu">');

                for (let i = page - 6; i < page; i++) {
                    if (i >= 0) {
                        $('#pages').append('<a class="item pageChoice">' + i + '</a>');
                    }
                }

                $('#pages').append('<a class="active item pageChoice">' + page + '</a>');

                for (let i = page + 1; i <= pages && i <= page + 5; i++) {
                    $('#pages').append('<a class="item pageChoice">' + i + '</a>');

                    if (i === page + 5) {
                        $('#pages').append('<a class="item">...</a>');
                    }
                }

                $('.pageChoice').click(event => {
                    page = parseInt(event.target.innerText);

                    if ($('#works').hasClass('active')) {
                        works()
                    } else {
                        educations();
                    }
                });
            });
        }
    </script>
</body>
</html>